local _, ns = ...
local WK = ns.WhoKnows
-------------------------------------------------------
function WK:tlength(T)
	if T == nil then return "NIL" end
	local count = 0
	for _ in pairs(T) do count = count + 1 end
	return count
end

function WK:deepcopy(o, seen)
	seen = seen or {}
	if o == nil then return nil end
	if seen[o] then return seen[o] end

	local no
	if type(o) == 'table' then
		no = {}
		seen[o] = no

		for k, v in next, o, nil do
			no[WK:deepcopy(k, seen)] = WK:deepcopy(v, seen)
		end
		setmetatable(no, WK:deepcopy(getmetatable(o), seen))
	else -- number, string, boolean, etc
	no = o
	end
	return no
end

function vardump(value, depth, key)
	local linePrefix = ""
	local spaces = ""

	if key ~= nil then
		linePrefix = "[" .. key .. "] = "
	end

	if depth == nil then
		depth = 0
	else
		depth = depth + 1
		for i = 1, depth do spaces = spaces .. "  " end
	end

	if type(value) == 'table' then
		local mTable = getmetatable(value)
		if mTable == nil then
			print(spaces .. linePrefix .. "(table) ")
		else
			print(spaces .. "(metatable) ")
			value = mTable
		end
		for tableKey, tableValue in pairs(value) do
			vardump(tableValue, depth, tableKey)
		end
	elseif type(value) == 'function' or
			type(value) == 'thread' or
			type(value) == 'userdata' or
			value == nil
	then
		print(spaces .. tostring(value))
	else
		print(spaces .. linePrefix .. "(" .. type(value) .. ") " .. tostring(value))
	end
end
